// SPDX-FileCopyrightText: Copyright (c) Ken Martin, Will Schroeder, Bill Lorensen
// SPDX-License-Identifier: BSD-3-Clause
#include "vtkGlyph3DVS.h"

const char *vtkGlyph3DVS =
"//VTK::System::Dec\n"
"\n"
"// SPDX-FileCopyrightText: Copyright (c) Ken Martin, Will Schroeder, Bill Lorensen\n"
"// SPDX-License-Identifier: BSD-3-Clause\n"
"// this shader is used to implement lighting in the fragment shader\n"
"// it handles setting up the basic varying variables for the fragment shader\n"
"\n"
"// all variables that represent positions or directions have a suffix\n"
"// indicating the coordinate system they are in. The possible values are\n"
"// MC - Model Coordinates\n"
"// WC - WC world coordinates\n"
"// VC - View Coordinates\n"
"// DC - Display Coordinates\n"
"\n"
"in vec4 vertexMC;\n"
"\n"
"// frag position in VC\n"
"//VTK::PositionVC::Dec\n"
"\n"
"// optional normal declaration\n"
"//VTK::Normal::Dec\n"
"\n"
"// Texture coordinates\n"
"//VTK::TCoord::Dec\n"
"\n"
"// material property values\n"
"//VTK::Color::Dec\n"
"\n"
"// camera and actor matrix values\n"
"//VTK::Camera::Dec\n"
"\n"
"//VTK::Glyph::Dec\n"
"\n"
"// clipping plane vars\n"
"//VTK::Clip::Dec\n"
"\n"
"// PointSize on GLES 3.0\n"
"//VTK::PointSizeGLES30::Dec\n"
"\n"
"void main()\n"
"{\n"
"  //VTK::Glyph::Impl\n"
"\n"
"  //VTK::Clip::Impl\n"
"\n"
"  //VTK::Color::Impl\n"
"\n"
"  //VTK::Normal::Impl\n"
"\n"
"  //VTK::TCoord::Impl\n"
"\n"
"  // frag position in VC\n"
"  //VTK::PositionVC::Impl\n"
"\n"
"  //VTK::PointSizeGLES30::Impl\n"
"}\n"
"";
