// java wrapper for vtkCompositeCharArray object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkABI.h"
#include "vtkSystemIncludes.h"
#include "vtkCompositeCharArray.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkDataArray_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkCompositeCharArray_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkCompositeCharArray",dType)) { return me; }
  if ((res= vtkDataArray_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCompositeCharArray_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCompositeCharArray* op = static_cast<vtkCompositeCharArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCompositeCharArray_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCompositeCharArray* op = static_cast<vtkCompositeCharArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCompositeCharArray_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCompositeCharArray* op = static_cast<vtkCompositeCharArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCompositeCharArray_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCompositeCharArray* op = static_cast<vtkCompositeCharArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCompositeCharArray_ExtendedNew_14(JNIEnv* env, jobject obj)
{
  vtkCompositeCharArray * temp20;

  vtkCompositeCharArray* op = static_cast<vtkCompositeCharArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ExtendedNew();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCompositeCharArray_GetDataType_15(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkCompositeCharArray* op = static_cast<vtkCompositeCharArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetDataType();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCompositeCharArray_GetTypedTuple_16(JNIEnv* env, jobject obj,jlong id0, jbyteArray id1, jint len1)
{
  long long   temp0;
  char * temp1;
  temp0 = id0;
  temp1 = vtkJavaUTF8ToChars(env, id1, len1);

  vtkCompositeCharArray* op = static_cast<vtkCompositeCharArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->GetTypedTuple(temp0,temp1);
  delete[] temp1;

}

extern "C" JNIEXPORT jchar  JNICALL Java_vtk_vtkCompositeCharArray_GetValue_17(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  char   temp20;
  temp0 = id0;

  vtkCompositeCharArray* op = static_cast<vtkCompositeCharArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetValue(temp0);
  return temp20;

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkCompositeCharArray_GetValueRange_18(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  char * temp20;
  temp0 = id0;

  vtkCompositeCharArray* op = static_cast<vtkCompositeCharArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetValueRange(temp0);
  return vtkJavaMakeJArrayOfByte(env, reinterpret_cast<jbyte*>(temp20), 2);

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkCompositeCharArray_GetValueRange_19(JNIEnv* env, jobject obj)
{
  char * temp20;

  vtkCompositeCharArray* op = static_cast<vtkCompositeCharArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetValueRange();
  return vtkJavaMakeJArrayOfByte(env, reinterpret_cast<jbyte*>(temp20), 2);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCompositeCharArray_FastDownCast_110(JNIEnv* env, jobject obj,jobject id0)
{
  vtkAbstractArray * temp0;
  vtkCompositeCharArray * temp20;
  temp0 = static_cast<vtkAbstractArray*>(vtkJavaGetPointerFromObject(env, id0));

  vtkCompositeCharArray* op = static_cast<vtkCompositeCharArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->FastDownCast(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCompositeCharArray_ConstructBackend_111(JNIEnv* env, jobject obj,jobject id0)
{
  vtkDataArrayCollection * temp0;
  temp0 = static_cast<vtkDataArrayCollection*>(vtkJavaGetPointerFromObject(env, id0));

  vtkCompositeCharArray* op = static_cast<vtkCompositeCharArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->ConstructBackend(temp0);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkCompositeCharArray_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkCompositeCharArray::New());
}
