// java wrapper for vtkAbstractCellArray object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkABI.h"
#include "vtkSystemIncludes.h"
#include "vtkAbstractCellArray.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkObject_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkAbstractCellArray_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkAbstractCellArray",dType)) { return me; }
  if ((res= vtkObject_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkAbstractCellArray_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkAbstractCellArray* op = static_cast<vtkAbstractCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkAbstractCellArray_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkAbstractCellArray* op = static_cast<vtkAbstractCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkAbstractCellArray_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkAbstractCellArray* op = static_cast<vtkAbstractCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkAbstractCellArray_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkAbstractCellArray* op = static_cast<vtkAbstractCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkAbstractCellArray_Initialize_14(JNIEnv* env, jobject obj)
{

  vtkAbstractCellArray* op = static_cast<vtkAbstractCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->Initialize();

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkAbstractCellArray_GetNumberOfCells_15(JNIEnv* env, jobject obj)
{
  long long   temp20;

  vtkAbstractCellArray* op = static_cast<vtkAbstractCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfCells();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkAbstractCellArray_GetNumberOfOffsets_16(JNIEnv* env, jobject obj)
{
  long long   temp20;

  vtkAbstractCellArray* op = static_cast<vtkAbstractCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfOffsets();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkAbstractCellArray_GetOffset_17(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  long long   temp20;
  temp0 = id0;

  vtkAbstractCellArray* op = static_cast<vtkAbstractCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOffset(temp0);
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkAbstractCellArray_GetNumberOfConnectivityIds_18(JNIEnv* env, jobject obj)
{
  long long   temp20;

  vtkAbstractCellArray* op = static_cast<vtkAbstractCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfConnectivityIds();
  return temp20;

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkAbstractCellArray_IsStorageShareable_19(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkAbstractCellArray* op = static_cast<vtkAbstractCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsStorageShareable();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkAbstractCellArray_IsHomogeneous_110(JNIEnv* env, jobject obj)
{
  long long   temp20;

  vtkAbstractCellArray* op = static_cast<vtkAbstractCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsHomogeneous();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkAbstractCellArray_GetCellAtId_111(JNIEnv* env, jobject obj,jlong id0,jobject id1)
{
  long long   temp0;
  vtkIdList * temp1;
  temp0 = id0;
  temp1 = static_cast<vtkIdList*>(vtkJavaGetPointerFromObject(env, id1));

  vtkAbstractCellArray* op = static_cast<vtkAbstractCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->GetCellAtId(temp0,temp1);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkAbstractCellArray_GetCellSize_112(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  long long   temp20;
  temp0 = id0;

  vtkAbstractCellArray* op = static_cast<vtkAbstractCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCellSize(temp0);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkAbstractCellArray_GetMaxCellSize_113(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkAbstractCellArray* op = static_cast<vtkAbstractCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMaxCellSize();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkAbstractCellArray_DeepCopy_114(JNIEnv* env, jobject obj,jobject id0)
{
  vtkAbstractCellArray * temp0;
  temp0 = static_cast<vtkAbstractCellArray*>(vtkJavaGetPointerFromObject(env, id0));

  vtkAbstractCellArray* op = static_cast<vtkAbstractCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->DeepCopy(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkAbstractCellArray_ShallowCopy_115(JNIEnv* env, jobject obj,jobject id0)
{
  vtkAbstractCellArray * temp0;
  temp0 = static_cast<vtkAbstractCellArray*>(vtkJavaGetPointerFromObject(env, id0));

  vtkAbstractCellArray* op = static_cast<vtkAbstractCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->ShallowCopy(temp0);

}
