// java wrapper for vtkCellGridElevation object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkABI.h"
#include "vtkSystemIncludes.h"
#include "vtkCellGridElevation.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkCellGridAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkCellGridElevation_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkCellGridElevation",dType)) { return me; }
  if ((res= vtkCellGridAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCellGridElevation_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCellGridElevation* op = static_cast<vtkCellGridElevation*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCellGridElevation_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCellGridElevation* op = static_cast<vtkCellGridElevation*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellGridElevation_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCellGridElevation* op = static_cast<vtkCellGridElevation*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellGridElevation_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCellGridElevation* op = static_cast<vtkCellGridElevation*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellGridElevation_SetAttributeName_14(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCellGridElevation* op = static_cast<vtkCellGridElevation*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetAttributeName(temp0);
  delete[] temp0;

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkCellGridElevation_GetAttributeName_15(JNIEnv* env, jobject obj)
{
  char * temp20;

  vtkCellGridElevation* op = static_cast<vtkCellGridElevation*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetAttributeName();
  return (temp20 == nullptr) ? env->NewByteArray(0) : vtkJavaCharsToUTF8(env, temp20, strlen(temp20));

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellGridElevation_SetOrigin_16(JNIEnv* env, jobject obj,jdouble id0,jdouble id1,jdouble id2)
{
  double   temp0;
  double   temp1;
  double   temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  vtkCellGridElevation* op = static_cast<vtkCellGridElevation*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOrigin(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellGridElevation_SetOrigin_17(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[3];
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);

  vtkCellGridElevation* op = static_cast<vtkCellGridElevation*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOrigin(temp0);

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkCellGridElevation_GetOrigin_18(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkCellGridElevation* op = static_cast<vtkCellGridElevation*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOrigin();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 3);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellGridElevation_SetNumberOfAxes_19(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkCellGridElevation* op = static_cast<vtkCellGridElevation*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetNumberOfAxes(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCellGridElevation_GetNumberOfAxesMinValue_110(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkCellGridElevation* op = static_cast<vtkCellGridElevation*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfAxesMinValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCellGridElevation_GetNumberOfAxesMaxValue_111(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkCellGridElevation* op = static_cast<vtkCellGridElevation*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfAxesMaxValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCellGridElevation_GetNumberOfAxes_112(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkCellGridElevation* op = static_cast<vtkCellGridElevation*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfAxes();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellGridElevation_SetAxis_113(JNIEnv* env, jobject obj,jdouble id0,jdouble id1,jdouble id2)
{
  double   temp0;
  double   temp1;
  double   temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  vtkCellGridElevation* op = static_cast<vtkCellGridElevation*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetAxis(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellGridElevation_SetAxis_114(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[3];
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);

  vtkCellGridElevation* op = static_cast<vtkCellGridElevation*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetAxis(temp0);

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkCellGridElevation_GetAxis_115(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkCellGridElevation* op = static_cast<vtkCellGridElevation*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetAxis();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 3);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellGridElevation_SetShock_116(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkCellGridElevation* op = static_cast<vtkCellGridElevation*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetShock(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkCellGridElevation_GetShock_117(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkCellGridElevation* op = static_cast<vtkCellGridElevation*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetShock();
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkCellGridElevation_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkCellGridElevation::New());
}
