// java wrapper for vtkDataObjectMeshCache object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkABI.h"
#include "vtkSystemIncludes.h"
#include "vtkDataObjectMeshCache.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkObject_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkDataObjectMeshCache_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkDataObjectMeshCache",dType)) { return me; }
  if ((res= vtkObject_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkDataObjectMeshCache_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkDataObjectMeshCache* op = static_cast<vtkDataObjectMeshCache*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkDataObjectMeshCache_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkDataObjectMeshCache* op = static_cast<vtkDataObjectMeshCache*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkDataObjectMeshCache_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkDataObjectMeshCache* op = static_cast<vtkDataObjectMeshCache*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkDataObjectMeshCache_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkDataObjectMeshCache* op = static_cast<vtkDataObjectMeshCache*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkDataObjectMeshCache_SetConsumer_14(JNIEnv* env, jobject obj,jobject id0)
{
  vtkAlgorithm * temp0;
  temp0 = static_cast<vtkAlgorithm*>(vtkJavaGetPointerFromObject(env, id0));

  vtkDataObjectMeshCache* op = static_cast<vtkDataObjectMeshCache*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetConsumer(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkDataObjectMeshCache_SetOriginalDataObject_15(JNIEnv* env, jobject obj,jobject id0)
{
  vtkDataObject * temp0;
  temp0 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id0));

  vtkDataObjectMeshCache* op = static_cast<vtkDataObjectMeshCache*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOriginalDataObject(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkDataObjectMeshCache_AddOriginalIds_16(JNIEnv* env, jobject obj,jint id0, jbyteArray id1, jint len1)
{
  int   temp0;
  std::string temp1;
  temp0 = id0;
  temp1 = vtkJavaUTF8ToString(env, id1, len1);

  vtkDataObjectMeshCache* op = static_cast<vtkDataObjectMeshCache*>(vtkJavaGetPointerFromObject(env, obj));
  op->AddOriginalIds(temp0,temp1);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkDataObjectMeshCache_RemoveOriginalIds_17(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkDataObjectMeshCache* op = static_cast<vtkDataObjectMeshCache*>(vtkJavaGetPointerFromObject(env, obj));
  op->RemoveOriginalIds(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkDataObjectMeshCache_ClearOriginalIds_18(JNIEnv* env, jobject obj)
{

  vtkDataObjectMeshCache* op = static_cast<vtkDataObjectMeshCache*>(vtkJavaGetPointerFromObject(env, obj));
  op->ClearOriginalIds();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkDataObjectMeshCache_CopyCacheToDataObject_19(JNIEnv* env, jobject obj,jobject id0)
{
  vtkDataObject * temp0;
  temp0 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id0));

  vtkDataObjectMeshCache* op = static_cast<vtkDataObjectMeshCache*>(vtkJavaGetPointerFromObject(env, obj));
  op->CopyCacheToDataObject(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkDataObjectMeshCache_UpdateCache_110(JNIEnv* env, jobject obj,jobject id0)
{
  vtkDataObject * temp0;
  temp0 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id0));

  vtkDataObjectMeshCache* op = static_cast<vtkDataObjectMeshCache*>(vtkJavaGetPointerFromObject(env, obj));
  op->UpdateCache(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkDataObjectMeshCache_InvalidateCache_111(JNIEnv* env, jobject obj)
{

  vtkDataObjectMeshCache* op = static_cast<vtkDataObjectMeshCache*>(vtkJavaGetPointerFromObject(env, obj));
  op->InvalidateCache();

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkDataObjectMeshCache_IsSupportedData_112(JNIEnv* env, jobject obj,jobject id0)
{
  vtkDataObject * temp0;
  bool   temp20;
  temp0 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id0));

  vtkDataObjectMeshCache* op = static_cast<vtkDataObjectMeshCache*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsSupportedData(temp0);
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkDataObjectMeshCache_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkDataObjectMeshCache::New());
}
