// java wrapper for vtkFDSReader object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkABI.h"
#include "vtkSystemIncludes.h"
#include "vtkFDSReader.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkPartitionedDataSetCollectionAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkFDSReader_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkFDSReader",dType)) { return me; }
  if ((res= vtkPartitionedDataSetCollectionAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkFDSReader_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkFDSReader* op = static_cast<vtkFDSReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkFDSReader_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkFDSReader* op = static_cast<vtkFDSReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkFDSReader_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkFDSReader* op = static_cast<vtkFDSReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkFDSReader_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkFDSReader* op = static_cast<vtkFDSReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkFDSReader_SetFileName_14(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  std::string   temp0;
  temp0 = vtkJavaUTF8ToString(env, id0, len0);

  vtkFDSReader* op = static_cast<vtkFDSReader*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetFileName(temp0);

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkFDSReader_GetFileName_15(JNIEnv* env, jobject obj)
{
  std::string   temp20;

  vtkFDSReader* op = static_cast<vtkFDSReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetFileName();
  return vtkJavaStringToUTF8(env, temp20);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkFDSReader_SetStream_16(JNIEnv* env, jobject obj,jobject id0)
{
  vtkResourceStream * temp0;
  temp0 = static_cast<vtkResourceStream*>(vtkJavaGetPointerFromObject(env, id0));

  vtkFDSReader* op = static_cast<vtkFDSReader*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetStream(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkFDSReader_GetStream_17(JNIEnv* env, jobject obj)
{
  vtkResourceStream * temp20;

  vtkFDSReader* op = static_cast<vtkFDSReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetStream();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkFDSReader_GetAssembly_18(JNIEnv* env, jobject obj)
{
  vtkDataAssembly * temp20;

  vtkFDSReader* op = static_cast<vtkFDSReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetAssembly();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkFDSReader_GetAssemblyTag_19(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkFDSReader* op = static_cast<vtkFDSReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetAssemblyTag();
  return temp20;

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkFDSReader_AddSelector_110(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  bool   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkFDSReader* op = static_cast<vtkFDSReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->AddSelector(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkFDSReader_ClearSelectors_111(JNIEnv* env, jobject obj)
{

  vtkFDSReader* op = static_cast<vtkFDSReader*>(vtkJavaGetPointerFromObject(env, obj));
  op->ClearSelectors();

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkFDSReader_GetTimeTolerance_112(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkFDSReader* op = static_cast<vtkFDSReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetTimeTolerance();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkFDSReader_SetTimeTolerance_113(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkFDSReader* op = static_cast<vtkFDSReader*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetTimeTolerance(temp0);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkFDSReader_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkFDSReader::New());
}
